//*****************************************************************************
//  Copyright (c) 2021 Glenfly Tech Co., Ltd.. 
//  All Rights Reserved.
//
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Glenfly Tech Co., Ltd..;
//  the contents of this file may not be disclosed to third parties, copied or
//  duplicated in any form, in whole or in part, without the prior written
//  permission of Glenfly Tech Co., Ltd..
//
//  The copyright of the source code is protected by the copyright laws of the People's
//  Republic of China and the related laws promulgated by the People's Republic of China
//  and the international covenant(s) ratified by the People's Republic of China. 
//*****************************************************************************

#ifndef __V4L2_H8_DEF_H__
#define __V4L2_H8_DEF_H__

//-----------------------------------------------
//match with Altek_AL6031_ISPxxxx_Note0912.xlsx
//-----------------------------------------------
#define DEV_NAME_PREVIEW     "/dev/video0"
#define DEV_NAME_FRONT       "/dev/video10"

#define V4L2_CID_H8_CUSTOM_BASE             (V4L2_CID_USER_BASE | 0xf000)
#define V4L2_CID_FLASH_MODE                 (V4L2_CID_H8_CUSTOM_BASE +  0)
#define V4L2_CID_AUTO_FOCUS_MODE            (V4L2_CID_H8_CUSTOM_BASE +  1)
#define V4L2_CID_AUTO_FOCUS_AREA_SET        (V4L2_CID_H8_CUSTOM_BASE +  2)
#define V4L2_CID_AWB_MODE                   (V4L2_CID_H8_CUSTOM_BASE +  3)
#define V4L2_CID_AUTO_EXPOSURE_SET          (V4L2_CID_H8_CUSTOM_BASE +  4)
#define V4L2_CID_METERING_MODE              (V4L2_CID_H8_CUSTOM_BASE +  5)
#define V4L2_CID_METERING_AREA_SET          (V4L2_CID_H8_CUSTOM_BASE +  6)
#define V4L2_CID_ISO_MODE                   (V4L2_CID_H8_CUSTOM_BASE +  7)
#define V4L2_CID_SHARPNESS_MODE             (V4L2_CID_H8_CUSTOM_BASE +  8)
#define V4L2_CID_ANTIBANDING_MODE           (V4L2_CID_H8_CUSTOM_BASE +  9)
#define V4L2_CID_RGB2YUV_FORMAT_MODE        (V4L2_CID_H8_CUSTOM_BASE + 10)
#define V4L2_CID_RGB2YUV_MATRIX_SET         (V4L2_CID_H8_CUSTOM_BASE + 11)
#define V4L2_CID_TONEMAP_MODE               (V4L2_CID_H8_CUSTOM_BASE + 12)
#define V4L2_CID_TONEMAP_CURVE_SET          (V4L2_CID_H8_CUSTOM_BASE + 13)
#define V4L2_CID_SPECIAL_EFFECT_MODE        (V4L2_CID_H8_CUSTOM_BASE + 14)
#define V4L2_CID_SCENARIO_MODE              (V4L2_CID_H8_CUSTOM_BASE + 15)
#define V4L2_CID_SATURATION_MODE            (V4L2_CID_H8_CUSTOM_BASE + 16)
#define V4L2_CID_CONTRAST_MODE              (V4L2_CID_H8_CUSTOM_BASE + 17)
#define V4L2_CID_SCENE_MODE_SET             (V4L2_CID_H8_CUSTOM_BASE + 18)
#define V4L2_CID_SHADINGCORRECT_MODE        (V4L2_CID_H8_CUSTOM_BASE + 19)
#define V4L2_CID_MANUAL_SHUTTER_SET         (V4L2_CID_H8_CUSTOM_BASE + 20)

#define V4L2_CID_MANUAL_FOCUS_SET           (V4L2_CID_H8_CUSTOM_BASE + 21)
#define V4L2_CID_MANUAL_WB_SET              (V4L2_CID_H8_CUSTOM_BASE + 22)
#define V4L2_CID_SENSOR_EFFECT_MODE         (V4L2_CID_H8_CUSTOM_BASE + 23)
#define V4L2_CID_LENS_INFO                  (V4L2_CID_H8_CUSTOM_BASE + 24)

#define V4L2_CID_STREAM_INIT                (V4L2_CID_H8_CUSTOM_BASE + 25)
#define V4L2_CID_MAIN_CTRL                  (V4L2_CID_H8_CUSTOM_BASE + 26)
#define V4L2_CID_LAST_ITEM                  (V4L2_CID_H8_CUSTOM_BASE + 27)     // keep it at the last

#define V4L2_H8_CTRL_NR(CTL_ID)             (CTL_ID - V4L2_CID_H8_CUSTOM_BASE)

enum H8_V4L2_CID_FLASH_MODE{
    V4L2_ISP_FLASH_OFF = 0,
    V4L2_ISP_FLASH_AUTO,
    V4L2_ISP_FLASH_ON,
};

enum H8_V4L2_CID_AUTO_FOCUS_MODE{
    V4L2_ISP_AF_FIXED = 0,
    V4L2_ISP_AF_AUTO,
    V4L2_ISP_AF_INFINITY,
    V4L2_ISP_AF_MACRO,
    V4L2_ISP_AF_CONTINUS_VIDEO,
    V4L2_ISP_AF_CONTINUS_PICTURE,
    V4L2_ISP_AF_MANUAL,
};

enum H8_V4L2_CID_AWB_MODE{
    V4L2_ISP_AWB_OFF = 0,
    V4L2_ISP_AWB_AUTO,
    V4L2_ISP_AWB_INCANDESCENT,
    V4L2_ISP_AWB_FLUORESCENT,
    V4L2_ISP_AWB_WARM_FLUORESCENT,
    V4L2_ISP_AWB_DAYLIGHT,
    V4L2_ISP_AWB_CLOUDY_DAYLIGHT,
    V4L2_ISP_AWB_TWILIGHT,
    V4L2_ISP_AWB_SHADE,
    V4L2_ISP_AWB_MANUAL,
};

enum H8_V4L2_CID_METERING_MODE{
    V4L2_ISP_METERING_OFF  = 0,
    V4L2_ISP_METERING_AUTO,
    V4L2_ISP_METERING_MANUAL,
};

enum H8_V4L2_CID_ISO_MODE{
    V4L2_ISP_ISO_AUTO = 0,
    V4L2_ISP_ISO_L100,
    V4L2_ISP_ISO_L200,
    V4L2_ISP_ISO_L400,
    V4L2_ISP_ISO_L800,
    V4L2_ISP_ISO_L1600,
    V4L2_ISP_ISO_L3200,
    V4L2_ISP_ISO_L6400,
    V4L2_ISP_ISO_L9600,
};

enum H8_V4L2_CID_SHARPNESS_MODE{
    V4L2_ISP_SHARPNESS_NORMAL = 0,
    V4L2_ISP_SHARPNESS_SOFT,
    V4L2_ISP_SHARPNESS_HARD,
};

enum H8_V4L2_CID_ANTIBANDING_MODE{
    V4L2_ISP_ANTIBANDING_OFF = 0,
    V4L2_ISP_ANTIBANDING_50HZ,
    V4L2_ISP_ANTIBANDING_60HZ,
};

enum H8_V4L2_CID_RGB2YUV_FORMAT_MODE{
    V4L2_ISP_RGB2YUV_BT601 = 0,
    V4L2_ISP_RGB2YUV_BT709,
    V4L2_ISP_RGB2YUV_USER,
};

enum H8_V4L2_CID_TONEMAP_MODE{
    V4L2_ISP_TONEMAP_FIX = 0,
    V4L2_ISP_TONEMAP_USER,
};

enum H8_V4L2_CID_SPECIAL_EFFECT_MODE{
    V4L2_ISP_SPECIAL_EFFECT_OFF = 0,
    V4L2_ISP_SPECIAL_EFFECT_GRAYSCALE,
    V4L2_ISP_SPECIAL_EFFECT_SEPIA,
    V4L2_ISP_SPECIAL_EFFECT_NEGATIVE,
    V4L2_ISP_SPECIAL_EFFECT_SOLARIZE,
    V4L2_ISP_SPECIAL_EFFECT_POSTERIZE,
    V4L2_ISP_SPECIAL_EFFECT_AQUA,
};

enum H8_V4L2_CID_SCENARIO_MODE{
    V4L2_ISP_SCENARIO_PREVIEW = 0,
    V4L2_ISP_SCENARIO_STILL_CAPTURE,
    V4L2_ISP_SCENARIO_STILL_HDR_1_1,
    V4L2_ISP_SCENARIO_STILL_HDR_2_1,
    V4L2_ISP_SCENARIO_STILL_HDR_3_1,
    V4L2_ISP_SCENARIO_ZERO_SHUTTER_LAG,
    V4L2_ISP_SCENARIO_DUAL_SHOT_FRONT_REAR,
    V4L2_ISP_SCENARIO_DUAL_SHOT_REARS,
    V4L2_ISP_SCENARIO_VIDEO_RECORD,
    V4L2_ISP_SCENARIO_VIDEO_SLOW_MOTION,
    V4L2_ISP_SCENARIO_VIDEO_FAST_FHD60,
    V4L2_ISP_SCENARIO_VIDEO_FAST_HD120,
    V4L2_ISP_SCENARIO_VIDEO_HDR_1_1,
    V4L2_ISP_SCENARIO_VIDEO_HDR_2_1,
    V4L2_ISP_SCENARIO_VIDEO_HDR_3_1,
    V4L2_ISP_SCENARIO_FRONT_PREVIEW,
};


enum H8_V4L2_CID_SATURATION_MODE{
    V4L2_ISP_SATURATION_NORMAL = 0,
    V4L2_ISP_SATURATION_LOW,
    V4L2_ISP_SATURATION_HIGH,
};

enum H8_V4L2_CID_CONTRAST_MODE{
    V4L2_ISP_CONTRAST_NORMAL = 0,
    V4L2_ISP_CONTRAST_LOW,
    V4L2_ISP_CONTRAST_HIGH,
};

enum H8_V4L2_CID_SCENE_MODE{
    V4L2_ISP_SCENE_AUTO = 0,
    V4L2_ISP_SCENE_PORTRAIT,
    V4L2_ISP_SCENE_BACKLIGHT,
    V4L2_ISP_SCENE_BACKLIGHT_PORTRAIT,
    V4L2_ISP_SCENE_SUNSET,
    V4L2_ISP_SCENE_NIGHT_LANDSCAPE,
    V4L2_ISP_SCENE_NIGHT_PORTRAIT,
    V4L2_ISP_SCENE_SPORT,
    V4L2_ISP_SCENE_BLUE_SKY,
    V4L2_ISP_SCENE_GREEN_PLANTS,
    V4L2_ISP_SCENE_VIDEO,
    V4L2_ISP_SCENE_PANORAMA,
    V4L2_ISP_SCENE_LANDSCAPE,
    V4L2_ISP_SCENE_TEXT,
    V4L2_ISP_SCENE_HDR,
    V4L2_ISP_SCENE_MANUAL,
};

enum H8_V4L2_CID_SHADINGCORRECT_MODE{
    V4L2_ISP_SHADING_OFF = 0,
    V4L2_ISP_SHADING_ON,
};

enum H8_V4L2_CID_OUTPUT_TYPE{
    V4L2_ISP_OUTPUT_RAW10 = 0,
    V4L2_ISP_OUTPUT_NV12,
    V4L2_ISP_OUTPUT_YUY2,
};

enum H8_V4L2_CID_TONEMAP_CURVE{
    V4L2_ISP_TONEMAP_CURVE_BLUE = 0,
    V4L2_ISP_TONEMAP_CURVE_GREEN,
    V4L2_ISP_TONEMAP_CURVE_RED,
};

enum H8_V4L2_CID_SENSOR_EFFECT_MODE{
    V4L2_ISP_SENSOR_EFFECT_NORMAL = 0,
    V4L2_ISP_SENSOR_EFFECT_MIRROR,
};

typedef struct _ISP_AREA_{
    unsigned short x;         //start x pos
    unsigned short y;         //start y pos
    unsigned short w;         //Rect width
    unsigned short h;         //Rect height
    unsigned short weight;    // 1~1000
    unsigned short reserved;
}ISP_AREA;

//----------------------------------------
typedef enum _H8V_STREAM_STATUS
{
    H8V_STREAM_DISABLE = 0,
    H8V_STREAM_PAUSE,
    H8V_STREAM_ON,
}H8V_STREAM_STATUS;

typedef enum _INPUT_STREAM_ID
{
    INPUT_STREAM_ID_MetaData = 0,   // 0
    INPUT_STREAM_ID_Preview,        // 1
    INPUT_STREAM_ID_Record,         // 2
    INPUT_STREAM_ID_PictureM,       // 3
    INPUT_STREAM_ID_PictureS,       // 4
    INPUT_STREAM_ID_MAX,            // 5
}INPUT_STREAM_ID;

typedef struct _FIFOBufferInfo
{
    unsigned int    alloc;
    unsigned int    pitch;
}FIFOBufferInfo;

#define H8V_STREAM_MASK_META        (1<<INPUT_STREAM_ID_MetaData)     // 0x01
#define H8V_STREAM_MASK_PREVIEW     (1<<INPUT_STREAM_ID_Preview)      // 0x02
#define H8V_STREAM_MASK_RECORD      (1<<INPUT_STREAM_ID_Record)       // 0x04
#define H8V_STREAM_MASK_PICTUREM    (1<<INPUT_STREAM_ID_PictureM)     // 0x08
#define H8V_STREAM_MASK_PICTURES    (1<<INPUT_STREAM_ID_PictureS)     // 0x10

typedef struct _FIFOBuffer
{
    unsigned int    card;
    unsigned int    device;

    unsigned int    stream_mask;
    FIFOBufferInfo  stream[INPUT_STREAM_ID_MAX];      // stream[id]
    unsigned int    reserved[24];
}*FIFOBuffer_ptr;

typedef struct _StreamInfo
{
    H8V_STREAM_STATUS   status;
    unsigned int        width;
    unsigned int        height;
}StreamInfo;

typedef struct _Stream_Init
{
    StreamInfo      stream_info[INPUT_STREAM_ID_MAX];     // stream_info[stream_id]
    unsigned int    reserved;
}Stream_Init;

typedef struct _ISP_Ctrl
{
    unsigned int    stream_mask;        // H8V_STREAM_MASK_XXX | H8V_STREAM_MASK_XXX
    StreamInfo      stream_info[INPUT_STREAM_ID_MAX];     // stream_info[stream_id]

    unsigned int    op_mask;            // operation mask
    unsigned int    handle_imm;         // handle this ctrl op immediately

    unsigned int    flash_mode;
    unsigned int    focus_mode;
    ISP_AREA        AF_area;
    unsigned int    awb_mode;
    unsigned int    AE;
    unsigned int    metering;
    ISP_AREA        metering_area;
    unsigned int    iso;
    unsigned int    sharpness;
    unsigned int    anti_banding;
    unsigned int    yuy2_format;
    unsigned int    yuy2_matrix[12];
    unsigned int    tonemap;
    unsigned int    tonemap_curve[3];   // 295*3 should be send down before this ctrl set.
    unsigned int    special_effect;
    unsigned int    scenario;
    unsigned int    saturation;
    unsigned int    contrast;
    unsigned int    scene;
    unsigned int    shading;
    unsigned int    manual_shutter;
    unsigned int    manual_focus;
    unsigned int    manual_wb;
    unsigned int    sensor_effect;
}ISP_Ctrl;

//---------------- for log -----------------
enum H8_V4L2_LOG_OPERATION_MODE{
    h8_nr_open = 0,
    h8_nr_VIDIOC_QUERYCAP,
    h8_nr_VIDIOC_S_FMT,
    h8_nr_VIDIOC_REQBUFS,
    h8_nr_VIDIOC_QBUF,
    h8_nr_VIDIOC_S_CTRL,
    h8_nr_VIDIOC_STREAMON,
    h8_nr_VIDIOC_DQBUF,
    h8_nr_VIDIOC_STREAMOFF,
    h8_nr_close,
    h8_nr_UNKNOWN,
};

#endif //__V4L2_H8_DEF_H__
